PROGRAM ETAD12;  { Demo Program Test ADC 12Bit LTC1298}
USES    CRT,DOS;

VAR     ADC_DATA    : Word;
        QUIT,EXIT   : Boolean;
        Ch          : Char;
        I           : Integer;

CONST   PortWrite   = $378;
        PortRead    = $379;
        Esc         = #27;

PROCEDURE ReadCH0(VAR ADC_DATA:WORD); {Read ADCLTC1298 Channel0}
VAR ReadCount : Integer;
    ADC_BUFF  : Word;
BEGIN
  PORT[PortWrite] := $0B;         {CS=1,CLK=1,DI=1 Initial Start Operation}
  PORT[PortWrite] := $03;         {CS "0" = Start Operation}
  PORT[PortWrite] := $01;         {DI "1" = Start Clock}
  PORT[PortWrite] := $03;
  PORT[PortWrite] := $01;         {DI "1" = SGL}
  PORT[PortWrite] := $03;
  PORT[PortWrite] := $00;         {DI "0" = ODD}
  PORT[PortWrite] := $02;
  PORT[PortWrite] := $01;         {DI "1" = MSBF}
  PORT[PortWrite] := $03;
  ADC_DATA := $0000;                             {Initial ADC Data Buffer}
  PORT[PortWrite] := $01;                        {CLK "0" = Start Clock}
  For ReadCount := 1 to 13 Do                    {Counter Read 13 Bit}
     Begin
       ADC_BUFF := PORT[PortRead] AND $0080 SHL 6;  {Read Data From Busy Printer}
       ADC_BUFF := ADC_BUFF SHR ReadCount;          {Save 1bit Data to Buffer}
       ADC_DATA := ADC_DATA OR ADC_BUFF;
       PORT[PortWrite] := $03;                      {CLK "1" = Rising Clock}
       PORT[PortWrite] := $01;                      {CLK "0" = Falling Clock}
  End;
  ADC_DATA := ADC_DATA AND $0FFF;                {Ignore Null Bit}
  PORT[PortWrite] := $0B;                        {CS "1" Stop Operation}
END;

PROCEDURE ReadCH1(VAR ADC_DATA:WORD); {Read ADCLTC1298 Channel1}
VAR ReadCount : Integer;
    ADC_BUFF  : Word;
BEGIN
  PORT[PortWrite] := $0B;         {CS=1,CLK=1,DI=1 Initial Start Operation}
  PORT[PortWrite] := $03;         {CS "0" = Start Operation}
  PORT[PortWrite] := $01;         {DI "1" = Start Clock}
  PORT[PortWrite] := $03;
  PORT[PortWrite] := $01;         {DI "1" = SGL}
  PORT[PortWrite] := $03;
  PORT[PortWrite] := $01;         {DI "1" = ODD}
  PORT[PortWrite] := $03;
  PORT[PortWrite] := $01;         {DI "1" = MSBF}
  PORT[PortWrite] := $03;
  ADC_DATA := $0000;                             {Initial ADC Data Buffer}
  PORT[PortWrite] := $01;                        {CLK "0" = Start Clock}
  For ReadCount := 1 to 13 Do                    {Counter Read 13 Bit}
     Begin
       ADC_BUFF := PORT[PortRead] AND $0080 SHL 6;  {Read Data From Busy Printer}
       ADC_BUFF := ADC_BUFF SHR ReadCount;          {Save 1bit Data to Buffer}
       ADC_DATA := ADC_DATA OR ADC_BUFF;
       PORT[PortWrite] := $03;                      {CLK "1" = Rising Clock}
       PORT[PortWrite] := $01;                      {CLK "0" = Falling Clock}
     End;
  ADC_DATA := ADC_DATA AND $0FFF;                {Ignore Null Bit}
  PORT[PortWrite] := $0B;                        {CS "1" Stop Operation}
END;

BEGIN   {MAIN}
  TextColor(0);
  TextBackground(0);
  Clrscr;
  TextBackGround(Blue);
  TextColor(Yellow);
  Gotoxy(19,01);Writeln('ͻ');
  Gotoxy(19,02);Writeln(' **>> Example Program For ET-AD12 <<** ');
  Gotoxy(19,03);Writeln(' Serial A/D 12-Bit : Interface on LPT1 ');
  Gotoxy(19,04);Writeln('   Product Design By.... ETT CO.,LTD.  ');
  Gotoxy(19,05);Writeln('͹');
  Gotoxy(19,06);Writeln('     A/D  CH0            A/D  CH1      ');
  Gotoxy(19,07);Writeln('                                       ');
  Gotoxy(19,08);Writeln('                                       ');
  Gotoxy(19,09);Writeln('͹');
  Gotoxy(19,10);Writeln('           Press Esc to Quit           ');
  Gotoxy(19,11);Writeln('ͼ');
  TextColor(12);
  Gotoxy(25,6);Write('A/D  CH0');
  Gotoxy(45,6);Write('A/D  CH1');
  Repeat
      While NOT Keypressed do
      BEGIN
          ReadCH0(ADC_DATA);
          TextColor(15);
          Gotoxy(26,7);Write(ADC_DATA:4,'    ');
          TextColor(10);
          Gotoxy(22,8);
          FOR I := 12 Downto 1 DO
          Write(ADC_DATA SHR (I-1) AND $1);
          Write('B');
          ReadCH1(ADC_DATA);
          TextColor(15);
          Gotoxy(47,7);Write(ADC_DATA:4,'    ');
          TextColor(10);
          Gotoxy(42,8);
          FOR I := 12 Downto 1 DO
          Write(ADC_DATA SHR (I-1) AND $1);
          Write('B');
      END;
      QUIT := False;
      Ch   := Readkey;
      CASE Ch OF
         Esc : BEGIN
                QUIT := True;
               END;
      ELSE QUIT := False;
      END;
  Until QUIT = True;
  TextColor(15);         {Clear Screen}
  TextBackground(0);
  Clrscr;
END.
